<?php

class Team extends AppModule
{
  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'Tean';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Allow users to create teams similar to guilds in the game.';
    $this->Dependencies = array('User');
  }
  
  function Start()
  {
  	$this->System->RegisterPage('team.php', 'PageTeam');
  }
}

include_once('img_level.php');

class PageTeam extends Page
{
	function ShowTeamList()
	{
		global $Config, $User;
	
		$Output = '<h3>Seznam překladatelských týmů</h3>';
		$Output .= 'Týmy jsou seskupení překladatelů, kteří se hlásí k něčemu společnému jako např. WoW serveru, způsobu překladu, ke stejnému hernímu spolku, aj. Být členem týmu samo o sobě nemá žádný zásadní důsledek a spíše to může pomoci se lépe orientovat mezi překladateli někomu, kdo sestavuje export.<br/>';
		$DbResult = $this->Database->query('SELECT COUNT(*) FROM `Team`');
		$DbRow = $DbResult->fetch_row();
		$PageList = GetPageList($DbRow[0]);
	
		$Output .= $PageList['Output'];
		$Output .= '<table class="BaseTable">';
	
		$TableColumns = array(
				array('Name' => 'Name', 'Title' => 'Jméno'),
				array('Name' => 'URL', 'Title' => 'Webové stránky'),
				array('Name' => 'LeaderName', 'Title' => 'Vedoucí'),
				array('Name' => 'NumberUser', 'Title' => 'Počet členů'),
				array('Name' => 'TimeCreate', 'Title' => 'Datum založení'),
		);
		if($User->Licence(LICENCE_USER)) $TableColumns[] = array('Name' => '', 'Title' => 'Uživatelské akce');
	
		$Order = GetOrderTableHeader($TableColumns, 'NumberUser', 1);
		$Output .= $Order['Output'];
	
		if(array_key_exists('search', $_GET)) $_SESSION['search'] = ' WHERE `Name` LIKE "%'.$_GET['search'].'%" OR `Description` LIKE "%'.$_GET['search'].'%"';
		else if(!array_key_exists('search', $_SESSION)) $_SESSION['search'] = '';
		if (array_key_exists('search', $_GET) and ($_GET['search'] == '')) $_SESSION['search'] = '';
	
		$DbResult = $this->Database->query('SELECT *, (SELECT COUNT(*) FROM `User` WHERE `User`.`Team` = `Team`.`Id`) AS `NumberUser`, (SELECT `Name` FROM `User` WHERE `User`.`ID`=`Team`.`Leader`) AS `LeaderName` FROM `Team` '.$_SESSION['search'].$Order['SQL'].$PageList['SQLLimit']);
		while($Team = $DbResult->fetch_assoc())
		{
			$Output .= '<tr>'.
					'<td><a href="?action=team&amp;id='.$Team['Id'].'">'.$Team['Name'].'</a></td>'.
					'<td><a href="http://'.$Team['URL'].'">'.$Team['URL'].'</a></td>'.
					'<td><a href="'.$this->System->Link('/user.php?user='.$Team['Leader']).'">'.$Team['LeaderName'].'</a></td>'.
					'<td><a href="userlist.php?team='.$Team['Id'].'" title="Zobrazit členy týmu">'.$Team['NumberUser'].'</a></td>'.
					'<td>'.HumanDate($Team['TimeCreate']).'</td>';
			if($User->Licence(LICENCE_USER))
			{
				if($Team['Leader'] == $User->Id) $Action = ' <a href="?action=modify&amp;id='.$Team['Id'].'">Upravit</a>';
				else $Action = '';
				if($Team['Id'] == $User->Team) $Action = ' <a href="?action=leave">Opustit</a>';
				$Output .= '<td><a href="?action=gointeam&amp;id='.$Team['Id'].'">Vstoupit</a>'.$Action.'</td>';
			}
			$Output .= '</tr>';
		}
		$Output .= '</table>'.
				$PageList['Output'];
	
		if($User->Licence(LICENCE_USER))
			$Output .= '<br /><div style="text-align: center;"><a href="?action=create">Vytvořit překladatelský tým</a></div>';
		return($Output);
	}
	
	function TeamJoin()
	{
		global $User;
	
		if($User->Licence(LICENCE_USER))
		{
			if(array_key_exists('id', $_GET))
			{
				$this->Database->query('UPDATE `User` SET `Team` = '.$_GET['id'].' WHERE `ID` = '.$User->Id);
				$Output = ShowMessage('Vstoupil jsi do týmu.');
				WriteLog('Uživatel vstoupil do týmu '.$_GET['id'], LOG_TYPE_USER);
	
				// Delete all teams without users
				$this->Database->query('DELETE FROM `Team` WHERE (SELECT COUNT(*) FROM `User` WHERE `User`.`Team` = `Team`.`Id`) = 0');
	
				// Set new leader for teams where old leader went to other team
				$this->Database->query('UPDATE `Team` SET `Leader`=(SELECT `Id` FROM `User` WHERE `User`.`Team`=`Team`.`Id` ORDER BY `User`.`RegistrationTime` LIMIT 1) WHERE `Leader` NOT IN (SELECT `ID` FROM `User` WHERE `User`.`Team`=`Team`.`Id`);');
	
				$Output .= $this->ShowTeamList();
			} else $Output = ShowMessage('Nutno zadat id týmu.', MESSAGE_CRITICAL);
		} else $Output = ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function TeamCreateFinish()
	{
		global $User;
	
		$Output = '';
		if($User->Licence(LICENCE_USER))
		{
			if(array_key_exists('Name', $_POST) and array_key_exists('Description', $_POST))
			{
				$DbResult = $this->Database->query('SELECT COUNT(*) FROM `Team` WHERE `Name` = "'.trim($_POST['Name']).'"');
				$DbRow = $DbResult->fetch_row();
				$Count = $DbRow[0];
				if(($Count == 0) and ($_POST['Name'] != ''))
				{
					$this->Database->query('INSERT INTO `Team` (`Name` ,`Description`, `URL`, `TimeCreate`, `Leader`)'.
							' VALUES ("'.trim($_POST['Name']).'", "'.trim($_POST['Description']).'", "'.
							$_POST['URL'].'", NOW(), '.$User->Id.')');
					$this->Database->query('UPDATE `User` SET `Team` = '.$this->Database->insert_id.' WHERE `ID` = '.$User->Id);
					$Output .= ShowMessage('Překladatelský tým vytvořen.');
					WriteLog('Překladatelský tým vytvořen '.$_POST['Name'], LOG_TYPE_USER);
	
					// Delete all teams without users
					$this->Database->query('DELETE FROM `Team` WHERE (SELECT COUNT(*) FROM `User` WHERE `User`.`Team` = `Team`.`Id`) = 0');
				} else $Output .= ShowMessage('Již existuje tým se stejným jménem', MESSAGE_CRITICAL);
			} else $Output .= ShowMessage('Chybí údaje formuláře', MESSAGE_CRITICAL);
		} else $Output .= ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
		$Output .= $this->ShowTeamList();
		return($Output);
	}
	
	function TeamModify()
	{
		global $User;
	
		if($User->Licence(LICENCE_USER))
		{
			if(array_key_exists('id', $_GET))
			{
				$DbResult = $this->Database->query('SELECT * FROM `Team` WHERE `Id`='.$_GET['id'].' AND `Leader`='.$User->Id);
				if($DbResult->num_rows > 0)
				{
					$Team = $DbResult->fetch_assoc();
					$Output = '<form action="?action=finish_modify&amp;id='.$_GET['id'].'" method="post">'.
							'<fieldset><legend>Nastavení týmu</legend>'.
							'<table><tr><td>Jméno:</td><td><input type="text" name="Name" value="'.$Team['Name'].'"/></td></tr>'.
							'<tr><td>Webové stránky:</td><td>http://<input type="text" name="URL" value="'.$Team['URL'].'"/></td></tr>'.
							'<tr><td>Popis:</td><td><input type="text" name="Description" value="'.$Team['Description'].'"/></td></tr>'.
							'<tr><td colspan="2"><input type="submit" value="Uložit" /></td></tr>'.
							'</table></fieldset></form>';
				} else $Output = ShowMesage('Tým nenalezen.', MESSAGE_CRITICAL);
			} else $Output = ShowMessage('Nezadáno id týmu', MESSAGE_CRITICAL);
		} else $Output = ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function TeamModifyFinish()
	{
		global $User;
	
		$Output = '';
		if($User->Licence(LICENCE_USER))
		{
			if(array_key_exists('id', $_GET) and array_key_exists('Name', $_POST) and array_key_exists('Description', $_POST) and array_key_exists('URL', $_POST))
			{
				$DbResult = $this->Database->query('SELECT * FROM `Team` WHERE `Id`='.$_GET['id'].' AND `Leader`='.$User->Id);
				if($DbResult->num_rows > 0)
				{
					$Team = $DbResult->fetch_assoc();
					$DbResult = $this->Database->query('SELECT COUNT(*) FROM `Team` WHERE `Name` = "'.trim($_POST['Name']).'"');
					$DbRow = $DbResult->fetch_row();
					$Count = $DbRow[0];
					if(($Count == 0) and ($_POST['Name'] != ''))
					{
						$this->Database->query('UPDATE `Team` SET `Name`="'.$_POST['Name'].'", `Description`="'.$_POST['Description'].'", `URL`="'.$_POST['URL'].'" WHERE Id='.$Team['Id']);
						$Output .= ShowMessage('Nastavení týmu uloženo.');
						WriteLog('Překladatelský tým upraven '.$_POST['Name'], LOG_TYPE_USER);
					} else $Output .= ShowMessage('Již existuje tým se stejným jménem.', MESSAGE_CRITICAL);
				} else $Output .= ShowMessage('Tým nenalezen nebo nemáte oprávnění.', MESSAGE_CRITICAL);
			} else $Output .= ShowMessage('Nezadáno id týmu nebo některé položky formuláře.', MESSAGE_CRITICAL);
		} else $Output .= ShowMessage('Nemáte oprávnění.', MESSAGE_CRITICAL);
		$Output .= $this->ShowTeamList();
		return($Output);
	}
	
	function TeamCreate()
	{
		global $User;
	
		if($User->Licence(LICENCE_USER))
		{
			$Output ='<form action="?action=finish_create" method="post">'.
					'<fieldset><legend>Vytvoření nového týmu</legend>'.
					'<table><tr><td>Jméno:</td><td><input type="text" name="Name" /></td></tr>'.
					'<tr><td>Webové stránky:</td><td>http://<input type="text" name="URL" value=""/></td></tr>'.
					'<tr><td>Popis:</td><td><input type="text" name="Description" /></td></tr>'.
					'<tr><td colspan="2"><input type="submit" value="Vytvořit a vstoupit" /></td></tr>'.
					'</table></fieldset></form>';
		} else $Output = ShowMessage('Nemáte oprávnění', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function TeamShow()
	{
		global $User, $Config;
	
		$Output = '';
		if(array_key_exists('id', $_GET) and is_numeric($_GET['id']))
		{
			ImgLevelUpdate();
	
			$DbResult = $this->Database->query('SELECT `Id`, `Name`, `Description`, `URL`, `Leader`, '.
					'(SELECT COUNT(*) FROM `User` WHERE '.
					'`Team` = `Team`.`Id`) AS `NumberUser`, (SELECT SUM(`TranslatedCount`) FROM `User` WHERE '.
					'`Team` = `Team`.`Id`) AS `NumberTranslate` FROM '.
					'`Team` WHERE `Id`='.($_GET['id'] * 1));
			if($DbResult->num_rows > 0)
			{
				$Team = $DbResult->fetch_assoc();
				$DbResult2 = $this->Database->query('SELECT `Name`, `Id` FROM `User` WHERE `ID`='.$Team['Leader']);
				if($DbResult2->num_rows > 0)
				{
					$Leader = $DbResult2->fetch_assoc();
				} else $Leader = array('Name' => '', 'Id' => 0);
	
				$Output .='<strong>Překladatelský tým '.$Team['Name'].'</strong><br />'.
						'Webové stránky: <a href="http://'.$Team['URL'].'">'.$Team['URL'].'</a><br/>'.
						'Vedoucí: <a href="'.$this->System->Link('/user.php?user='.$Leader['Id']).'">'.$Leader['Name'].'</a><br/>'.
						'Popis: '.$Team['Description'].'<br /><br />';
				//$Output .= '<a href="export/?team='.$Team['Id'].'">Exportovat překlad týmu</a> ';
				if($User->Licence(LICENCE_USER))
					$Output .='<a href="?action=gointeam&amp;id='.$Team['Id'].'">Vstoupit do týmu</a><br /><br />';
				$Output .='<fieldset><legend>Statistika</legend>'.
						'Počet členů týmu: <a href="userlist.php?team='.$Team['Id'].'" title="Zobrazit členy týmu">'.$Team['NumberUser'].'</a><br />'.
						'Počet přeložených textů týmu: <strong>'.$Team['NumberTranslate'].'</strong><br />'.
						'Průměrná úroveň překladatelů v týmu: <img src="tmp/team/'.$Team['Name'].'/level.png" /><br /><br />'.
						'<strong>Stav dokončení týmu pro verzi '.$Config['Web']['GameVersion'].'</strong><br />';
	
				$BuildNumber = GetBuildNumber($Config['Web']['GameVersion']);
	
				$GroupListQuery = 'SELECT `Group`.* FROM `Group`';
				$Query = '';
				$DbResult = $this->Database->query($GroupListQuery);
				if($DbResult->num_rows > 0)
				{
					while($DbRow = $DbResult->fetch_assoc())
					{
						$Query .= 'SELECT (SELECT COUNT(DISTINCT(`Entry`)) FROM ('.
								'SELECT `T`.`Entry` FROM `'.$DbRow['TablePrefix'].'` AS `T` '.
								'WHERE (`User` IN (SELECT `ID` FROM `User` WHERE `Team` = '.$Team['Id'].')) '.
								'AND (`Complete` = 1) AND (`T`.`Language`!='.$Config['OriginalLanguage'].') '.
								'AND (`VersionStart` <= '.$BuildNumber.') AND (`VersionEnd` >= '.$BuildNumber.')'.
								') AS `C1`) AS `Translated`, '.
								'(SELECT COUNT(DISTINCT(`Entry`)) FROM ('.
								'SELECT `T`.`Entry` FROM `'.$DbRow['TablePrefix'].'` AS `T` '.
								'WHERE (`Language` = '.$Config['OriginalLanguage'].') '.
								'AND (`VersionStart` <= '.$BuildNumber.') AND (`VersionEnd` >= '.$BuildNumber.')'.
								') AS `C2`) AS `Total`, "'.$DbRow['Name'].'" AS `Name` UNION ';
					}
					$Query = substr($Query, 0, - 6);
	
					$DbResult = $this->Database->query('SELECT COUNT(*) FROM ('.$GroupListQuery.') AS `T`');
					$DbRow = $DbResult->fetch_row();
					$PageList = GetPageList($DbRow[0]);
					$Output .= $PageList['Output'];
	
					$Output .='<table class="BaseTable">';
					$TableColumns = array(
							array('Name' => 'Name', 'Title' => 'Jméno'),
							array('Name' => 'Translated', 'Title' => 'Přeložených'),
							array('Name' => 'Total', 'Title' => 'Anglických'),
							array('Name' => 'Percent', 'Title' => 'Procenta'),
					);
	
					$Order = GetOrderTableHeader($TableColumns, 'Name', 0);
					$Output .= $Order['Output'];
	
					$Translated = 0;
					$Total = 0;
					$DbResult = $this->Database->query('SELECT *, ROUND(`Translated` / `Total` * 100, 2) AS `Percent` FROM ('.$Query.') AS `C3` '.$Order['SQL'].$PageList['SQLLimit']);
					while($Group = $DbResult->fetch_assoc())
					{
						$Output .='<tr><td>'.$Group['Name'].'</td><td>'.$Group['Translated'].'</td><td>'.$Group['Total'].'</td><td>'.ProgressBar(150, $Group['Percent']).'</td></tr>';
						$Translated += $Group['Translated'];
						$Total += $Group['Total'];
					}
					if($Total > 0) $Progress = round($Translated / $Total * 100, 2);
					else $Progress = 0;
					$Output .='<tr><td><strong>Celkem</strong></td><td><strong>'.$Translated.'</strong></td><td><strong>'.$Total.'</strong></td><td><strong>'.ProgressBar(150, $Progress).'</strong></td></tr>';
					$Output .='</table>';
				}
				$Output .='</fieldset>';
			} else $Output .= ShowMessage('Tým nenalezen', MESSAGE_CRITICAL);
		} else $Output .= ShowMessage('Musíte zadat id týmu', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function TeamLeave()
	{
		global $User;
	
		if($User->Licence(LICENCE_USER))
		{
			$this->Database->query('UPDATE `User` SET `Team` = NULL WHERE `ID` = '.$User->Id);
			$Output = ShowMessage('Nyní nejste členem žádného týmu.');
			WriteLog('Uživatel vystoupil z týmu', LOG_TYPE_USER);
	
			// Delete all teams without users
			$this->Database->query('DELETE FROM `Team` WHERE (SELECT COUNT(*) FROM `User` WHERE `User`.`Team` = `Team`.`Id`) = 0');
	
			// Set new leader for teams where old leader went to other team
			$this->Database->query('UPDATE `Team` SET `Leader`=(SELECT `Id` FROM `User` WHERE `User`.`Team`=`Team`.`Id` ORDER BY `User`.`RegistrationTime` LIMIT 1) WHERE `Leader` NOT IN (SELECT `ID` FROM `User` WHERE `User`.`Team`=`Team`.`Id`);');
	
			$Output .= $this->ShowTeamList();
		} else $Output = ShowMessage('Nemáte oprávnění.', MESSAGE_CRITICAL);
		return($Output);
	}
	
	function Show()
	{
		if(array_key_exists('action', $_GET))
		{
			if($_GET['action'] == 'gointeam') $Output = $this->TeamJoin();
			else if($_GET['action'] == 'finish_create') $Output = $this->TeamCreateFinish();
			else if($_GET['action'] == 'modify') $Output = $this->TeamModify();
			else if($_GET['action'] == 'finish_modify') $Output = $this->TeamModifyFinish();
			else if($_GET['action'] == 'create') $Output = $this->TeamCreate();
			else if($_GET['action'] == 'team') $Output = $this->TeamShow();
			else if($_GET['action'] == 'leave') $Output = $this->TeamLeave();
			else $Output = $this->ShowTeamList();
		} else $Output = $this->ShowTeamList();
		return($Output);
	}
}